import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkSpec, ThinkSpecParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询商品规格组记录表
 */
export async function pageThinkSpec(params: ThinkSpecParam) {
  const res = await request.get<ApiResult<PageResult<ThinkSpec>>>(
    THINK_API_URL + '/think/think-spec/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品规格组记录表列表
 */
export async function listThinkSpec(params?: ThinkSpecParam) {
  const res = await request.get<ApiResult<ThinkSpec[]>>(
    THINK_API_URL + '/think/think-spec',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品规格组记录表
 */
export async function addThinkSpec(data: ThinkSpec) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-spec',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品规格组记录表
 */
export async function updateThinkSpec(data: ThinkSpec) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-spec',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品规格组记录表
 */
export async function removeThinkSpec(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-spec/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品规格组记录表
 */
export async function removeBatchThinkSpec(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-spec/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品规格组记录表
 */
export async function getThinkSpec(id: number) {
  const res = await request.get<ApiResult<ThinkSpec>>(
    THINK_API_URL + '/think/think-spec/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
